package com.netifera.platform.net.internal.daemon.sniffing;

import com.netifera.platform.net.daemon.sniffing.IPacketModuleContext;
import com.netifera.platform.net.pcap.ICaptureHeader;
import com.netifera.platform.net.sniffing.IPacketContext;

public class PacketModuleContext implements IPacketModuleContext {
	
	private final IPacketContext packetContext;
	private final ISniffingModuleOutput output;
	PacketModuleContext(IPacketContext ctx, ISniffingModuleOutput output) {
		this.packetContext = ctx;
		this.output = output;
	}

	public ICaptureHeader getCaptureHeader() {
		return packetContext.getCaptureHeader();
	}

	public long getRealm() {
		return packetContext.getRealm();
	}

	public long getSpaceId() {
		return packetContext.getSpaceId();
	}

	public void setRealm(long realm) {
		packetContext.setRealm(realm);		
	}
	
	public void printOutput(String message) {
		output.printOutput(message);
	}

}
