package com.netifera.platform.net.internal.daemon.sniffing;

import com.netifera.platform.net.daemon.sniffing.IStreamModuleContext;
import com.netifera.platform.net.sniffing.stream.ISessionContext;
import com.netifera.platform.net.sniffing.stream.ISessionKey;

public class StreamModuleContext implements IStreamModuleContext {

	private final ISessionContext sessionContext;
	private final ISniffingModuleOutput output;
	StreamModuleContext(ISessionContext ctx, ISniffingModuleOutput output) {
		this.sessionContext = ctx;
		this.output = output;
	}
	public ISessionKey getKey() {
		return sessionContext.getKey();
	}

	public long getRealm() {
		return sessionContext.getRealm();
	}

	public long getSpaceId() {
		return sessionContext.getSpaceId();
	}
	
	public void printOutput(String message) {
		output.printOutput(message);
	}

}
