package com.netifera.platform.net.internal.sniffing.managers;

import com.netifera.platform.net.pcap.ICaptureInterface;
import com.netifera.platform.net.sniffing.IPacketFilter;
import com.netifera.platform.net.sniffing.stream.IStreamSniffer;
import com.netifera.platform.net.sniffing.stream.IStreamSnifferHandle;

public class TCPStreamSnifferHandle implements IStreamSnifferHandle {

	private final IPacketFilter filter;
	private final IStreamSniffer sniffer;
	private final TCPManager manager;
	private long realm;
	private long spaceId;
	
	public TCPStreamSnifferHandle(TCPManager tcpManager,
			IPacketFilter filter, IStreamSniffer sniffer) {
		if(tcpManager == null) {
			throw new IllegalArgumentException("tcp manager is null");
		}
				
		this.filter = filter;
		this.sniffer = sniffer;
		this.manager = tcpManager;
		
	}
	
	public ICaptureInterface getInterface() {
		return manager.getInterface();
	}

	public IPacketFilter getFilter() {
		return filter;
	}
	
	public IStreamSniffer getSniffer() {
		return sniffer;
	}
	
	public void register() {
		manager.registerStreamHandle(this);
	}

	public void unregister() {
		manager.unregisterStreamHandle(this);
	}

	public long getSpaceId() {
		return spaceId;
	}
	
	public void setSpaceId(long spaceId) {
		this.spaceId = spaceId;
	}
	
	public long getRealm() {
		return realm;
	}

	public void setRealm(long realm) {
		this.realm = realm;
	}
}
