package com.netifera.platform.net.sniffing.util;

import com.netifera.platform.api.log.ILogger;
import com.netifera.platform.net.pcap.ICaptureInterface;
import com.netifera.platform.net.pcap.IPacketCapture;
import com.netifera.platform.net.pcap.IPacketHandler;

/**
 * This interface provides access to some internal methods for use by internal
 * components.
 */
public interface ISniffingEngineEx {
	
	/**
	 * Create a new pcap instance for the specified interface and bound to
	 * the given handler.  The snaplen, promiscuous flag, and timeout value
	 * will be set to values configured in the sniffing engine.
	 * 
	 * @param iface Network interface to create a pcap instance for.
	 * @param handler The packet handler bound to this pcap instance.
	 * 
	 * @return New <code>IPacketCapture</code> instance.
	 */
	IPacketCapture pcapCreate(ICaptureInterface iface, IPacketHandler handler);
	
	ILogger getLogger();
	
	void removeCaptureFileInterface(CaptureFileInterface iface);
}
